#/*==========================================================================*
# *    Copyright(c) 2021, Vertiv Tech Co., Ltd.
# *                     ALL RIGHTS RESERVED
# *
# *  PRODUCT  : ACU(Advanced Controller Unit)
# *
# *  FILENAME : Makefile
# *  CREATOR  : Frank Mao                DATE: 2004-09-10 20:00
# *  VERSION  : V1.00
# *  PURPOSE  : The make file for PLC service..
# *
# *  HISTORY  :
# *
# *==========================================================================*/

include $(ACU_SOURCE_DIR)/config_vars.mk

#the target output file
EXEC = plc.so

#the head files the object files depend on
INCS = plc.h

#the object files to generate the target
OBJS = plc.o 



#for self test
TEST_EXEC = test_plc
TEST_OBJS = test_plc.o #plc.o

#private shared libraries
LIBS = -ldl

all: $(EXEC)

$(EXEC): $(OBJS) $(INCS) $(PUBINCS)
	$(CC) -shared $(CFLAGS) $(LDFLAGS) -o $@ $(OBJS) $(LIBS) $(PUBLIBS)
	ln -fs `pwd`/$(EXEC) $(ACU_SOURCE_DIR)/service/$(EXEC)
	
ifeq ($(ACU_MAKE_VERSION_N), debug)
install: $(EXEC)
	-mkdir -p $(ACU_TARGET_DIR)/service/
	#-cp $(EXEC) $(ACU_TARGET_DIR)/service/
	cp -rf  $(EXEC) $(ACU_TARGET_DIR)/service/$(EXEC)
	chmod +x $(ACU_TARGET_DIR)/service/$(EXEC)	
else
install: $(EXEC)
	-mkdir -p $(ACU_TARGET_DIR)/service/
	#-cp $(EXEC) $(ACU_TARGET_DIR)/service/
	$(STRIP) -s -o $(ACU_TARGET_DIR)/service/$(EXEC) $(EXEC)
	chmod +x $(ACU_TARGET_DIR)/service/$(EXEC)
endif
		
$(TEST_EXEC): $(EXEC) $(TEST_OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(TEST_OBJS) $(TEST_LIBS) $(EXEC) $(PUBLIBS)
	#$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(TEST_OBJS) $(TEST_LIBS) $(EXEC)
	
test: $(TEST_EXEC)
	-echo Test making ...

clean:
	-rm -f $(EXEC) *.gdb *.elf *.o $(OBJS) core $(TEST_EXEC)
	-rm -f make_*.txt *.map
	-rm -f  $(ACU_SOURCE_DIR)/service/$(EXEC)
	